const eejs = require('ep_etherpad-lite/node/eejs/');
const settings = require('ep_etherpad-lite/node/utils/Settings');

exports.eejsBlock_editbarMenuLeft = (hookName, args, cb) => {
  args.content += eejs.require('ep_ethertoff_label_inserter/templates/editbarButtons.ejs');
  return cb();
};

// exports.padInitToolbar = function (hook_name, args) {
//   var toolbar = args.toolbar;

//   var insertTag = toolbar.button({
//       command: 'insertTag',
//       localizationId: 'ep_ethertoff_generator.toolbar.insertTag.title',
//       class: "buttonicon buttonicon-microphone-alt"
//   });

//   toolbar.registerButton('insertTag', insertTag);
// };


/**
 * ClientVars hook
 *
 * Exposes plugin settings from settings.json to client code inside clientVars variable
 * to be accessed from client side hooks
 *
 * @param {string} hookName Hook name ("clientVars").
 * @param {object} args Object containing the arguments passed to hook. {pad: {object}}
 * @param {function} cb Callback
 *
 * @returns {*} callback
 *
 * @see {@link http://etherpad.org/doc/v1.5.7/#index_clientvars}
 * https://github.com/citizenos/ep_image_upload/blob/master/index.js
 */
exports.clientVars = (hookName, args, cb) => {
  if (!settings.ep_ethertoff_label_inserter) {
    settings.ep_ethertoff_label_inserter = {}
  }

  return cb({ ep_ethertoff_label_inserter: {
    'ethertoff_api_url': '/api/labels',
    ...settings.ep_ethertoff_label_inserter
  }});
};
