let getLabels = (callback) => {
  let params = new URL(document.location).searchParams,
      folderSlug = params.get("folderSlug"),
      apiUrl = clientVars.ep_ethertoff_label_inserter.ethertoff_api_url,
      labelUrl = (folderSlug && folderSlug != '') ? apiUrl + '/labels/' + folderSlug : apiUrl + '/labels';
  
  jQuery.ajax({
    'url': labelUrl,
    'success': data => {
          callback(data.labels)
        },
  })

  // console.log('Client vars:')
  // console.log(clientVars)
  // callback(
  //   [
  //     ["quote", "quote"],
  //     ["question", "question"],
  //     ["opinion", "opinion"],
  //     ["reflection", "reflection"],
  //     ["interesting-practice", "interesting practice"],
  //     ["mood", "mood"],
  //     ["red-thread", "red thread"]
  //   ]
  // );
}

// Bind the event handler to the toolbar buttons
exports.postAceInit = (hookName, context) => {
  console.log(document.URL);
  const label_select = $('#ethertoff-label-selection');
  label_select.val('select-label').niceSelect('update');

  getLabels((labels) => {
    labels.forEach(label => {
      const option = document.createElement('option'),
            value = label,
            labelText = label;

      option.setAttribute('value', value);
      option.appendChild(document.createTextNode(labelText));
      
      label_select.append(option)
    });

    label_select.niceSelect('update');
  });

  label_select.on('change', function () {
    const value = $(this).val();
    if (value != 'select-label') {
      context.ace.callWithAce((ace) => {
        ace.ace_doInsertLabel(value);
      }, 'insertlabel', true);
      label_select.val('select-label').niceSelect('update');
    }
  });
};

// Once ace is initialized, we set ace_doInsertLabel and bind it to the context
exports.aceInitialized = (hookName, context) => {
  const editorInfo = context.editorInfo;
  
  editorInfo.ace_doInsertLabel = (label) => {
    const {editorInfo, rep} = context;
    if (!(rep.selStart && rep.selEnd)) return;
    
    // There is no selection only a cursor
    if (rep.selStart[0] == rep.selEnd[0] && rep.selStart[1] == rep.selEnd[1]) {
      editorInfo.editor.replaceRange(rep.selStart, rep.selEnd, '[[' + label + ']]');
    }
    
    // Text was selected, wrap with the label
    else {
      // Insert end first, to avoid the coordinates to be shifted
      // ace.ace_replaceRange(rep.selEnd, rep.selEnd, ']]');
      editorInfo.editor.replaceRange(rep.selEnd, rep.selEnd, ']]');
      // Insert start
      editorInfo.editor.replaceRange(rep.selStart, rep.selStart, '[['+ label + ' | ');
    }

    // ace.ace_focus();
  };
};
